#!/usr/bin/env node
import { PublishModeEnum as v } from "./utils/types.mjs";
import { PublishVersionTypeEnum as e, PublishTagEnum as P } from "./utils/enums.mjs";
import { inc as f, prerelease as N } from "semver";
import { join as h } from "node:path";
import { execSync as o } from "node:child_process";
import u from "pinyin";
import { readFileSync as A, existsSync as S } from "node:fs";
import p from "chalk";
import $ from "prompts";
const d = "/.dc/publish.json", O = "/package.json", w = ({ gitOriginName: i = "origin" }) => {
  try {
    const n = o("git rev-parse HEAD").toString().trim(), m = o('git log -1 --pretty=format:"%an"').toString().trim(), a = o('git log -1 --pretty=format:"%ae"').toString().trim(), s = o('git log -1 --pretty=format:"%s"').toString().trim(), r = o("git config user.name").toString().trim(), c = o("git config user.email").toString().trim(), g = o("git rev-parse --abbrev-ref HEAD").toString().trim();
    let R = "";
    try {
      R = o(`git config --get remote.${i}.url`).toString().trim();
    } catch {
      throw new Error(`git remote ${i} 不存在`);
    }
    return {
      lastHash: n,
      lastCommitter: m,
      lastCommitterPinYin: u(m, {
        style: u.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      lastCommitEmail: a,
      lastCommitMsg: s,
      userName: r,
      userNamePinYin: u(r, {
        style: u.STYLE_NORMAL,
        heteronym: !1
      }).join(""),
      userEmail: c,
      branchName: g,
      remoteUrl: R
    };
  } catch (n) {
    throw console.error("Error fetching git information:", n), n;
  }
}, E = (i, n = JSON.parse(A(h(process.cwd(), O), "utf-8"))) => {
  let m = n.name, a = "", s;
  const { version: r } = n;
  if ([
    e.MAJOR,
    e.MINOR,
    e.PATCH
  ].includes(i))
    a = f(r, i), s = P.LATEST;
  else if ([
    e.PREMAJOR,
    e.PREMINOR,
    e.PREPATCH
  ].includes(i)) {
    const c = N(r);
    c ? (console.log(
      p.yellow("当前版本已经是预发布版本，将会在当前版本基础上进行发布")
    ), c.length === 1 && typeof c[0] == "number" ? a = f(
      r,
      e.PRERELEASE
    ) : a = r.split("-")[0] + "-0") : a = f(r, i), s = P.NEXT;
  } else
    s = P.ALPHA, a = f(
      r,
      e.PRERELEASE,
      s
    );
  if (!a)
    throw new Error("version is empty");
  return {
    name: m,
    version: a,
    tag: s
  };
}, I = () => {
  let i;
  const n = h(process.cwd(), d);
  if (S(n)) {
    const m = A(n, "utf-8");
    i = JSON.parse(m);
  } else
    console.log(
      p.yellow(`未找到配置文件，将使用默认配置
      { gitOriginName: "origin" }
    `)
    );
  return {
    gitOriginName: "origin",
    ...i || {}
  };
}, k = async (i) => {
  console.log(i);
  const { mode: n, type: m, push: a } = i, s = I(), r = w(s);
  console.log("gitInfo:", r);
  let c = m, g;
  if (c)
    console.log("type:", c), g = await E(c);
  else {
    const t = JSON.parse(A(h(process.cwd(), O), "utf-8")), l = {
      [e.MAJOR]: E(
        e.MAJOR,
        t
      ),
      [e.MINOR]: E(
        e.MINOR,
        t
      ),
      [e.PATCH]: E(
        e.PATCH,
        t
      ),
      [e.PREMAJOR]: E(
        e.PREMAJOR,
        t
      ),
      [e.PREMINOR]: E(
        e.PREMINOR,
        t
      ),
      [e.PREPATCH]: E(
        e.PREPATCH,
        t
      ),
      [e.PRERELEASE]: E(
        e.PRERELEASE,
        t
      )
    }, y = [
      {
        title: `主版本(${l[e.MAJOR].version})`,
        value: e.MAJOR
      },
      {
        title: `次版本(${l[e.MINOR].version})`,
        value: e.MINOR
      },
      {
        title: `修订版本(${l[e.PATCH].version})`,
        value: e.PATCH
      },
      {
        title: `预发布主版本(${l[e.PREMAJOR].version})`,
        value: e.PREMAJOR
      },
      {
        title: `预发布次版本(${l[e.PREMINOR].version})`,
        value: e.PREMINOR
      },
      {
        title: `预发布修订版本(${l[e.PREPATCH].version})`,
        value: e.PREPATCH
      },
      {
        title: `alpha版本(${l[e.PRERELEASE].version})`,
        value: e.PRERELEASE
      }
    ];
    c = (await $({
      type: "select",
      name: "type",
      message: `请选择发布类型，当前版本：${t.version}`,
      choices: y,
      validate: (M) => M ? !0 : "请选择发布类型"
    })).type, g = l[c];
  }
  const { version: R } = g;
  console.log("npmInfo:", g), o(`npm version ${R} 1>&2`);
  try {
    if (n === v.NPM) {
      const { tag: t } = g;
      o(`npm publish --tag ${t} 1>&2`);
    } else if (n === v.WEB) {
      const { webBuild: t } = s;
      t ? o(`${t} 1>&2`) : console.log(p.yellow("webBuild为空，不执行web构建"));
    } else
      throw new Error("未知命令");
  } catch (t) {
    console.log(p.red(`发布失败, error: ${t.message}`));
    try {
      console.log(
        p.blue(`回滚本地版本到发布前的版本：${r.lastHash}`)
      );
      const { lastHash: l } = r;
      o(`git reset --hard ${l} 1>&2`), console.log(p.blue(`删除本次发布时生成的tag：v${g.version}`)), o(`git tag -d v${g.version} 1>&2`);
    } catch (l) {
      console.log(p.red(`回滚失败, error: ${l.message}`));
    }
    return process.exit(1);
  }
  a && (o(`git push ${s.gitOriginName} v${g.version} 1>&2`), o(`git push ${s.gitOriginName} ${r.branchName} 1>&2`)), console.log(p.green("发布成功"));
};
export {
  k as handler
};
